/*----- PROTECTED REGION ID(Agilent33x20AClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        Agilent33x20AClass.h
//
// description : Include for the Agilent33x20A root class.
//               This class is the singleton class for
//                the Agilent33x20A device class.
//               It contains all properties and methods which the 
//               Agilent33x20A requires only once e.g. the commands.
//
// project :     Agilent 33x20a signal generator
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Agilent33x20AClass_H
#define Agilent33x20AClass_H

#include <tango.h>
#include <Agilent33x20A.h>

/*----- PROTECTED REGION END -----*/	//	Agilent33x20AClass.h


namespace Agilent33x20A_ns
{
/*----- PROTECTED REGION ID(Agilent33x20AClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	Agilent33x20AClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute Frequency class definition
class FrequencyAttrib: public Tango::Attr
{
public:
	FrequencyAttrib():Attr("Frequency",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~FrequencyAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33x20A *>(dev))->read_Frequency(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33x20A *>(dev))->write_Frequency(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33x20A *>(dev))->is_Frequency_allowed(ty);}
};

//	Attribute Voltage class definition
class VoltageAttrib: public Tango::Attr
{
public:
	VoltageAttrib():Attr("Voltage",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~VoltageAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33x20A *>(dev))->read_Voltage(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33x20A *>(dev))->write_Voltage(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33x20A *>(dev))->is_Voltage_allowed(ty);}
};

//	Attribute VoltageOffset class definition
class VoltageOffsetAttrib: public Tango::Attr
{
public:
	VoltageOffsetAttrib():Attr("VoltageOffset",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~VoltageOffsetAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33x20A *>(dev))->read_VoltageOffset(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33x20A *>(dev))->write_VoltageOffset(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33x20A *>(dev))->is_VoltageOffset_allowed(ty);}
};

//	Attribute Function class definition
class FunctionAttrib: public Tango::Attr
{
public:
	FunctionAttrib():Attr("Function",
			Tango::DEV_STRING, Tango::READ_WRITE) {};
	~FunctionAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33x20A *>(dev))->read_Function(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33x20A *>(dev))->write_Function(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33x20A *>(dev))->is_Function_allowed(ty);}
};

//	Attribute SweepStartFrequency class definition
class SweepStartFrequencyAttrib: public Tango::Attr
{
public:
	SweepStartFrequencyAttrib():Attr("SweepStartFrequency",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~SweepStartFrequencyAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33x20A *>(dev))->read_SweepStartFrequency(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33x20A *>(dev))->write_SweepStartFrequency(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33x20A *>(dev))->is_SweepStartFrequency_allowed(ty);}
};

//	Attribute SweepStopFrequency class definition
class SweepStopFrequencyAttrib: public Tango::Attr
{
public:
	SweepStopFrequencyAttrib():Attr("SweepStopFrequency",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~SweepStopFrequencyAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33x20A *>(dev))->read_SweepStopFrequency(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33x20A *>(dev))->write_SweepStopFrequency(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33x20A *>(dev))->is_SweepStopFrequency_allowed(ty);}
};

//	Attribute SweepSpacing class definition
class SweepSpacingAttrib: public Tango::Attr
{
public:
	SweepSpacingAttrib():Attr("SweepSpacing",
			Tango::DEV_STRING, Tango::READ_WRITE) {};
	~SweepSpacingAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33x20A *>(dev))->read_SweepSpacing(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33x20A *>(dev))->write_SweepSpacing(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33x20A *>(dev))->is_SweepSpacing_allowed(ty);}
};

//	Attribute SweepTime class definition
class SweepTimeAttrib: public Tango::Attr
{
public:
	SweepTimeAttrib():Attr("SweepTime",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~SweepTimeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33x20A *>(dev))->read_SweepTime(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33x20A *>(dev))->write_SweepTime(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33x20A *>(dev))->is_SweepTime_allowed(ty);}
};

//	Attribute TriggerSource class definition
class TriggerSourceAttrib: public Tango::Attr
{
public:
	TriggerSourceAttrib():Attr("TriggerSource",
			Tango::DEV_STRING, Tango::READ_WRITE) {};
	~TriggerSourceAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33x20A *>(dev))->read_TriggerSource(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33x20A *>(dev))->write_TriggerSource(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33x20A *>(dev))->is_TriggerSource_allowed(ty);}
};

//	Attribute BurstCycles class definition
class BurstCyclesAttrib: public Tango::Attr
{
public:
	BurstCyclesAttrib():Attr("BurstCycles",
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~BurstCyclesAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33x20A *>(dev))->read_BurstCycles(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33x20A *>(dev))->write_BurstCycles(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33x20A *>(dev))->is_BurstCycles_allowed(ty);}
};

//	Attribute BurstPhase class definition
class BurstPhaseAttrib: public Tango::Attr
{
public:
	BurstPhaseAttrib():Attr("BurstPhase",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~BurstPhaseAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33x20A *>(dev))->read_BurstPhase(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33x20A *>(dev))->write_BurstPhase(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33x20A *>(dev))->is_BurstPhase_allowed(ty);}
};

//	Attribute BurstRate class definition
class BurstRateAttrib: public Tango::Attr
{
public:
	BurstRateAttrib():Attr("BurstRate",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~BurstRateAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33x20A *>(dev))->read_BurstRate(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33x20A *>(dev))->write_BurstRate(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33x20A *>(dev))->is_BurstRate_allowed(ty);}
};

//	Attribute Mode class definition
class ModeAttrib: public Tango::Attr
{
public:
	ModeAttrib():Attr("Mode",
			Tango::DEV_STRING, Tango::READ_WRITE) {};
	~ModeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33x20A *>(dev))->read_Mode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33x20A *>(dev))->write_Mode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33x20A *>(dev))->is_Mode_allowed(ty);}
};

//	Attribute ModulationSource class definition
class ModulationSourceAttrib: public Tango::Attr
{
public:
	ModulationSourceAttrib():Attr("ModulationSource",
			Tango::DEV_STRING, Tango::READ_WRITE) {};
	~ModulationSourceAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33x20A *>(dev))->read_ModulationSource(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33x20A *>(dev))->write_ModulationSource(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33x20A *>(dev))->is_ModulationSource_allowed(ty);}
};

//	Attribute ModulationFrequency class definition
class ModulationFrequencyAttrib: public Tango::Attr
{
public:
	ModulationFrequencyAttrib():Attr("ModulationFrequency",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~ModulationFrequencyAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33x20A *>(dev))->read_ModulationFrequency(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33x20A *>(dev))->write_ModulationFrequency(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33x20A *>(dev))->is_ModulationFrequency_allowed(ty);}
};

//	Attribute ModulationFunction class definition
class ModulationFunctionAttrib: public Tango::Attr
{
public:
	ModulationFunctionAttrib():Attr("ModulationFunction",
			Tango::DEV_STRING, Tango::READ_WRITE) {};
	~ModulationFunctionAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33x20A *>(dev))->read_ModulationFunction(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33x20A *>(dev))->write_ModulationFunction(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33x20A *>(dev))->is_ModulationFunction_allowed(ty);}
};

//	Attribute AMDepth class definition
class AMDepthAttrib: public Tango::Attr
{
public:
	AMDepthAttrib():Attr("AMDepth",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AMDepthAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33x20A *>(dev))->read_AMDepth(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33x20A *>(dev))->write_AMDepth(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33x20A *>(dev))->is_AMDepth_allowed(ty);}
};

//	Attribute FMDeviation class definition
class FMDeviationAttrib: public Tango::Attr
{
public:
	FMDeviationAttrib():Attr("FMDeviation",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~FMDeviationAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33x20A *>(dev))->read_FMDeviation(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33x20A *>(dev))->write_FMDeviation(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33x20A *>(dev))->is_FMDeviation_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command On class definition
class OnClass : public Tango::Command
{
public:
	OnClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OnClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OnClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Agilent33x20A *>(dev))->is_On_allowed(any);}
};

//	Command Off class definition
class OffClass : public Tango::Command
{
public:
	OffClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OffClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OffClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Agilent33x20A *>(dev))->is_Off_allowed(any);}
};

//	Command Reset class definition
class ResetClass : public Tango::Command
{
public:
	ResetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ResetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ResetClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Agilent33x20A *>(dev))->is_Reset_allowed(any);}
};


/**
 *	The Agilent33x20AClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  Agilent33x20AClass : public Tango::DeviceClass
#else
class Agilent33x20AClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(Agilent33x20AClass::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33x20AClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static Agilent33x20AClass *init(const char *);
		static Agilent33x20AClass *instance();
		~Agilent33x20AClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		Agilent33x20AClass(string &);
		static Agilent33x20AClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	Agilent33x20A_H
